from intersectionLib import *
#-------------(初期４都市設定用関数)----------------
def setMinMax(cityXY):     #■最大・最小値設定
    maxX=-1E30;maxY=-1E30;minX=1E30;minY=1E30
    for i in range(len(cityXY)):
        if cityXY[i][0]>maxX:maxX=cityXY[i][0]
        if cityXY[i][1]>maxY:maxY=cityXY[i][1]
        if cityXY[i][0]<minX:minX=cityXY[i][0]
        if cityXY[i][1]<minY:minY=cityXY[i][1]
    return [[minX,minY],[maxX,maxY]]
def nearXY(cityXY, X0,Y0): #■座標(X0,Y0)に最も近い都市
    minR2=setDist2(cityXY[0],[X0,Y0]); ID=0
    for i in range(1,len(cityXY)):
        R2=setDist2(cityXY[i],[X0,Y0])
        if R2<minR2: ID=i; minR2=R2
    return [ID,minR2]
def farXY(cityXY,X0,Y0):   #■座標(X0,Y0)から最も離れた都市
    maxR2=setDist2(cityXY[0],[X0,Y0]); ID=0
    for i in range(1,len(cityXY)):
        R2=setDist2(cityXY[i],[X0,Y0])
        if R2>maxR2: ID=i; maxR2=R2
    return [ID,maxR2]
def startSquare(cityXY,MM):#■外側から初期四角形設定
    XX=[]; k=[[0,0],[1,0],[1,1],[0,1]]
    for i in range(len(k)):
        D=nearXY(cityXY, MM[k[i][0]][0],MM[k[i][1]][1])
        ID=D[0]; XX.append(cityXY[ID]);del cityXY[ID]
    return XX
def centerP(MM):#■中央位置
    return [(MM[0][0]+MM[1][0])*0.5,(MM[0][1]+MM[1][1])*0.5]
def swap(XX,ID1,ID2):
    T=XX[ID1];XX[ID1]=XX[ID2];XX[ID2]=T
def startSquare2(cityXY,MM):#■内側から初期四角形設定
    XX=array(4); XY=centerP(MM);X0=XY[0];Y0=XY[1]
    for i in range(4):
        DD=nearXY(cityXY, X0,Y0);ID=DD[0]
        XX[i]=cityXY[ID];del cityXY[ID]
    DD=nearXY(XX,MM[0][0],MM[0][1]); ID=DD[0]
    if ID!=0:swap(XX,0,ID)#先頭は左上
    DD=nearXY(XX,MM[1][0],MM[1][1]); ID=DD[0]
    if ID!=2:swap(XX,2,ID)#3番目(添え字2)は右下
    if XX[1][0]<XX[3][0]: swap(XX,1,ID)
    return XX
